#    secureme is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    secureme is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with secureme.  If not, see <http://www.gnu.org/licenses/>.

#-----------------------------------------------------------------------------------------#

# Author: Federico Salotti
# Organization/Company: Mr_Robot_Computers_Repair
# Country: Italy Barga(LU)
# release: 1.1 (30 January 2020 16:36)


import random
import argparse
import os

version="secureme 1.1"

parser=argparse.ArgumentParser()

parser.add_argument("-length",help="set password length",type=int,default=8)
parser.add_argument("-nopunctuaction",help="discard punctuaction symbols",action="store_true")
parser.add_argument("-nonumbers",help="discard numbers",action="store_true")
parser.add_argument("-noaccents",help="discard accents",action="store_true")
parser.add_argument("-exclude",help="discard specific chars. Use with [-chars]",action="store_true")
parser.add_argument("-chars",help="list of chars to discard. Use with [-exclude]",nargs="+",dest="exclude_chars")
parser.add_argument("-name",help="set name of generated file",default="secureme_password.txt")
parser.add_argument("-path",help="set path of generated file" ,default=".")
parser.add_argument("-v",help="version",action="store_true")

args=parser.parse_args()

if args.exclude:

	for x in args.exclude_chars:
		splitted_chars=list(x)
		for y in splitted_chars:
			args.exclude_chars.append(y)

		args.exclude_chars.remove(x)

def exclude(chars,exclude_list):
	for x in exclude_list:
		for y in chars:
			if x == y:
				chars.remove(y)
				exclude(chars,exclude_list)

def gen_passwd():

	global used_args
	used_args=""

	i=0
	password=""

	security_check=0

	if not args.nopunctuaction and not args.noaccents:
    	 charList=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "!","\"","'","£","$","%","&","/","\\","(",")","=","?","^","{","}","[","]","+","*","@","#",";",",","§","-","_","<",">",
            "!","£","$","%","&","?","@","§",
            "!","£","$","%","&","?","@","§",
            "!","£","$","%","&","?","@","§",
            "à","è","ì","ò","ù",
            "á","é","í","ó","ú",
            "Á","É","Í","Ó","Ú",
             "˜","~"]

	elif not args.nopunctuaction and args.noaccents:
		charList=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "!","\"","'","£","$","%","&","/","\\","(",")","=","?","^","{","}","[","]","+","*","@","#",";",",","§","-","_","<",">"]

	elif args.nopunctuaction and args.noaccents:
		charList=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0"]

	elif args.nopunctuaction and not args.noaccents:
		charList=["a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "1","2","3","4","5","6","7","8","9","0",
            "à","è","ì","ò","ù",
            "á","é","í","ó","ú",
            "Á","É","Í","Ó","Ú",
             "˜","~"]


	if args.nonumbers:
		while(i<len(charList)):
			if charList[i] == "0" or charList[i] == "1" or charList[i] == "2" or charList[i] == "3" or charList[i] == "4" or charList[i] == "5" or charList[i] == "6" or charList[i] == "7" or charList[i] == "8" or charList[i] == "9":
				charList.remove(charList[i])
				i-=1
			else:
				i+=1

		used_args+="-nonumbers"

	if args.exclude:

		exclude(charList,args.exclude_chars)
		used_args+="-exclude -chars "+str(args.exclude_chars)
		used_args=used_args.replace(']',"").replace('[',"").replace('\'','').replace(',','').replace(' ','')
		used_args+=" "

	if args.noaccents:
		used_args+="-noaccents "

	if args.nopunctuaction:
		used_args+="-nopunctuaction "

	used_args+="-length "+str(args.length)

	i=0
	max_len=len(charList)-1

	while i<args.length:
		password+=charList[random.randint(0,max_len)]
		i+=1


	print ("[*] Password security control...")

	if not args.nopunctuaction:
		for x in password:
			if x=="!" or x=="£" or x=="$" or x=="%" or x=="&" or x=="?" or x=="@" or x=="§":
				security_check+=1
				break
	else:
		security_check=1


	if security_check!=0:
		print ("[+] Password security control [ PASSED ]")
		print ("[*] Saving password...")
		os.chdir(args.path)
		fopen=open(args.name,"w")
		fopen.write("\t\t\tSecureME v.1.1\n\n")
		fopen.write("Developed by: MR_ROBOT_COMPUTERS_REPAIR\n\n")
		used_args=used_args.replace('-nonumbers','-nonumbers ').replace('-exclude','-exclude ').replace('-chars','-chars ').replace('-nopunctuaction','-nopunctuaction ').replace('-length','-length ')
		fopen.write("command: secureme.py "+used_args+"\n\n")
		fopen.write("Password: "+password)
		fopen.close()
		print ("[+] Password successfully saved!")

	else:
		print ("[!] Password security control [ NOT PASSED ]")
		print ("[*] Generating another password...")
		return gen_passwd()


if args.v:
	print(version)
	quit()

gen_passwd()


